/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var SyntaxWalker = (function () {
        function SyntaxWalker() {
        }
        SyntaxWalker.prototype.walk = function (node) {
            this.visitNode(node);
        };
        SyntaxWalker.prototype.visitAnyKeyword = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitArrowFunction = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBinaryExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBindingElement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBlock = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitBreakStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitCallExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitCaseClause = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitClassDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitCatchClause = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitConditionalExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitConstructorDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitConstructorType = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitContinueStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitDebuggerStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitDefaultClause = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitDoStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitElementAccessExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitEnumDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitExportAssignment = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitExpressionStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitForStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitForInStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitForOfStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitFunctionDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitFunctionExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitFunctionType = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitGetAccessor = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitIdentifier = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitIfStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitImportDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitImportEqualsDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitIndexSignatureDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitInterfaceDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitLabeledStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitMethodDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitMethodSignature = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitModuleDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNamedImports = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNamespaceImport = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNewExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitObjectLiteralExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitParameterDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPostfixUnaryExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPrefixUnaryExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertyAccessExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertyAssignment = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertyDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitPropertySignature = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitRegularExpressionLiteral = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitReturnStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitSetAccessor = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitSourceFile = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitSwitchStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTemplateExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitThrowStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTryStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTypeAssertionExpression = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitTypeLiteral = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitVariableDeclaration = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitVariableStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitWhileStatement = function (node) {
            this.walkChildren(node);
        };
        SyntaxWalker.prototype.visitNode = function (node) {
            switch (node.kind) {
                case 112:
                    this.visitAnyKeyword(node);
                    break;
                case 153:
                    this.visitBindingElement(node);
                    break;
                case 164:
                    this.visitArrowFunction(node);
                    break;
                case 170:
                    this.visitBinaryExpression(node);
                    break;
                case 153:
                    this.visitBindingElement(node);
                    break;
                case 180:
                    this.visitBlock(node);
                    break;
                case 191:
                    this.visitBreakStatement(node);
                    break;
                case 158:
                    this.visitCallExpression(node);
                    break;
                case 221:
                    this.visitCaseClause(node);
                    break;
                case 202:
                    this.visitClassDeclaration(node);
                    break;
                case 224:
                    this.visitCatchClause(node);
                    break;
                case 171:
                    this.visitConditionalExpression(node);
                    break;
                case 136:
                    this.visitConstructorDeclaration(node);
                    break;
                case 144:
                    this.visitConstructorType(node);
                    break;
                case 190:
                    this.visitContinueStatement(node);
                    break;
                case 198:
                    this.visitDebuggerStatement(node);
                    break;
                case 222:
                    this.visitDefaultClause(node);
                    break;
                case 185:
                    this.visitDoStatement(node);
                    break;
                case 157:
                    this.visitElementAccessExpression(node);
                    break;
                case 205:
                    this.visitEnumDeclaration(node);
                    break;
                case 215:
                    this.visitExportAssignment(node);
                    break;
                case 183:
                    this.visitExpressionStatement(node);
                    break;
                case 187:
                    this.visitForStatement(node);
                    break;
                case 188:
                    this.visitForInStatement(node);
                    break;
                case 189:
                    this.visitForOfStatement(node);
                    break;
                case 201:
                    this.visitFunctionDeclaration(node);
                    break;
                case 163:
                    this.visitFunctionExpression(node);
                    break;
                case 143:
                    this.visitFunctionType(node);
                    break;
                case 137:
                    this.visitGetAccessor(node);
                    break;
                case 65:
                    this.visitIdentifier(node);
                    break;
                case 184:
                    this.visitIfStatement(node);
                    break;
                case 210:
                    this.visitImportDeclaration(node);
                    break;
                case 209:
                    this.visitImportEqualsDeclaration(node);
                    break;
                case 141:
                    this.visitIndexSignatureDeclaration(node);
                    break;
                case 203:
                    this.visitInterfaceDeclaration(node);
                    break;
                case 195:
                    this.visitLabeledStatement(node);
                    break;
                case 135:
                    this.visitMethodDeclaration(node);
                    break;
                case 134:
                    this.visitMethodSignature(node);
                    break;
                case 206:
                    this.visitModuleDeclaration(node);
                    break;
                case 213:
                    this.visitNamedImports(node);
                    break;
                case 212:
                    this.visitNamespaceImport(node);
                    break;
                case 159:
                    this.visitNewExpression(node);
                    break;
                case 155:
                    this.visitObjectLiteralExpression(node);
                    break;
                case 130:
                    this.visitParameterDeclaration(node);
                    break;
                case 169:
                    this.visitPostfixUnaryExpression(node);
                    break;
                case 168:
                    this.visitPrefixUnaryExpression(node);
                    break;
                case 156:
                    this.visitPropertyAccessExpression(node);
                    break;
                case 225:
                    this.visitPropertyAssignment(node);
                    break;
                case 133:
                    this.visitPropertyDeclaration(node);
                    break;
                case 132:
                    this.visitPropertySignature(node);
                    break;
                case 9:
                    this.visitRegularExpressionLiteral(node);
                    break;
                case 192:
                    this.visitReturnStatement(node);
                    break;
                case 138:
                    this.visitSetAccessor(node);
                    break;
                case 228:
                    this.visitSourceFile(node);
                    break;
                case 194:
                    this.visitSwitchStatement(node);
                    break;
                case 172:
                    this.visitTemplateExpression(node);
                    break;
                case 196:
                    this.visitThrowStatement(node);
                    break;
                case 197:
                    this.visitTryStatement(node);
                    break;
                case 161:
                    this.visitTypeAssertionExpression(node);
                    break;
                case 146:
                    this.visitTypeLiteral(node);
                    break;
                case 199:
                    this.visitVariableDeclaration(node);
                    break;
                case 181:
                    this.visitVariableStatement(node);
                    break;
                case 186:
                    this.visitWhileStatement(node);
                    break;
                default:
                    this.walkChildren(node);
                    break;
            }
        };
        SyntaxWalker.prototype.walkChildren = function (node) {
            var _this = this;
            ts.forEachChild(node, function (child) { return _this.visitNode(child); });
        };
        return SyntaxWalker;
    })();
    Lint.SyntaxWalker = SyntaxWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Lint;
(function (Lint) {
    var RuleWalker = (function (_super) {
        __extends(RuleWalker, _super);
        function RuleWalker(sourceFile, options) {
            _super.call(this);
            this.position = 0;
            this.failures = [];
            this.options = options.ruleArguments;
            this.sourceFile = sourceFile;
            this.limit = this.sourceFile.getFullWidth();
            this.disabledIntervals = options.disabledIntervals;
            this.ruleName = options.ruleName;
        }
        RuleWalker.prototype.getSourceFile = function () {
            return this.sourceFile;
        };
        RuleWalker.prototype.getFailures = function () {
            return this.failures;
        };
        RuleWalker.prototype.getLimit = function () {
            return this.limit;
        };
        RuleWalker.prototype.getOptions = function () {
            return this.options;
        };
        RuleWalker.prototype.hasOption = function (option) {
            if (this.options) {
                return this.options.indexOf(option) !== -1;
            }
            else {
                return false;
            }
        };
        RuleWalker.prototype.skip = function (node) {
            this.position += node.getFullWidth();
        };
        RuleWalker.prototype.createFailure = function (start, width, failure) {
            var from = (start > this.limit) ? this.limit : start;
            var to = ((start + width) > this.limit) ? this.limit : (start + width);
            return new Lint.RuleFailure(this.sourceFile, from, to, failure, this.ruleName);
        };
        RuleWalker.prototype.addFailure = function (failure) {
            if (!this.existsFailure(failure) && !Lint.doesIntersect(failure, this.disabledIntervals)) {
                this.failures.push(failure);
            }
        };
        RuleWalker.prototype.existsFailure = function (failure) {
            return this.failures.some(function (f) { return f.equals(failure); });
        };
        return RuleWalker;
    })(Lint.SyntaxWalker);
    Lint.RuleWalker = RuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var ScopeAwareRuleWalker = (function (_super) {
        __extends(ScopeAwareRuleWalker, _super);
        function ScopeAwareRuleWalker(sourceFile, options) {
            _super.call(this, sourceFile, options);
            this.scopeStack = [this.createScope()];
        }
        ScopeAwareRuleWalker.prototype.createScope = function () {
            throw Lint.abstract();
        };
        ScopeAwareRuleWalker.prototype.getCurrentScope = function () {
            return this.scopeStack[this.scopeStack.length - 1];
        };
        ScopeAwareRuleWalker.prototype.getAllScopes = function () {
            return this.scopeStack.slice();
        };
        ScopeAwareRuleWalker.prototype.getCurrentDepth = function () {
            return this.scopeStack.length;
        };
        ScopeAwareRuleWalker.prototype.onScopeStart = function () {
            return;
        };
        ScopeAwareRuleWalker.prototype.onScopeEnd = function () {
            return;
        };
        ScopeAwareRuleWalker.prototype.visitNode = function (node) {
            var isNewScope = this.isScopeBoundary(node);
            if (isNewScope) {
                this.scopeStack.push(this.createScope());
            }
            this.onScopeStart();
            _super.prototype.visitNode.call(this, node);
            this.onScopeEnd();
            if (isNewScope) {
                this.scopeStack.pop();
            }
        };
        ScopeAwareRuleWalker.prototype.isScopeBoundary = function (node) {
            return node.kind === 201
                || node.kind === 163
                || node.kind === 225
                || node.kind === 226
                || node.kind === 135
                || node.kind === 136
                || node.kind === 206
                || node.kind === 164
                || node.kind === 162
                || node.kind === 202
                || node.kind === 203
                || node.kind === 137
                || node.kind === 138;
        };
        return ScopeAwareRuleWalker;
    })(Lint.RuleWalker);
    Lint.ScopeAwareRuleWalker = ScopeAwareRuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var Formatters;
    (function (Formatters) {
        var AbstractFormatter = (function () {
            function AbstractFormatter() {
            }
            AbstractFormatter.prototype.format = function (failures) {
                throw Lint.abstract();
            };
            return AbstractFormatter;
        })();
        Formatters.AbstractFormatter = AbstractFormatter;
    })(Formatters = Lint.Formatters || (Lint.Formatters = {}));
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * Copyright 2014 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    function createLanguageServiceHost(fileName, source) {
        var host = {
            getCompilationSettings: function () { return Lint.createCompilerOptions(); },
            getCurrentDirectory: function () { return ""; },
            getDefaultLibFileName: function () { return "lib.d.ts"; },
            getScriptFileNames: function () { return [fileName]; },
            getScriptIsOpen: function () { return true; },
            getScriptSnapshot: function () {
                return {
                    getChangeRange: function (oldSnapshot) { return undefined; },
                    getLength: function () { return source.length; },
                    getLineStartPositions: function () { return ts.computeLineStarts(source); },
                    getText: function (start, end) { return source.substring(start, end); }
                };
            },
            getScriptVersion: function () { return "1"; },
            log: function (message) { }
        };
        return host;
    }
    Lint.createLanguageServiceHost = createLanguageServiceHost;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var Rules;
    (function (Rules) {
        var AbstractRule = (function () {
            function AbstractRule(ruleName, value, disabledIntervals) {
                var ruleArguments = [];
                if (Array.isArray(value) && value.length > 1) {
                    ruleArguments = value.slice(1);
                }
                this.value = value;
                this.options = {
                    disabledIntervals: disabledIntervals,
                    ruleArguments: ruleArguments,
                    ruleName: ruleName
                };
            }
            AbstractRule.prototype.getOptions = function () {
                return this.options;
            };
            AbstractRule.prototype.apply = function (sourceFile) {
                throw Lint.abstract();
            };
            AbstractRule.prototype.applyWithWalker = function (walker) {
                walker.walk(walker.getSourceFile());
                return walker.getFailures();
            };
            AbstractRule.prototype.isEnabled = function () {
                var value = this.value;
                if (typeof value === "boolean") {
                    return value;
                }
                if (Array.isArray(value) && value.length > 0) {
                    return value[0];
                }
                return false;
            };
            return AbstractRule;
        })();
        Rules.AbstractRule = AbstractRule;
    })(Rules = Lint.Rules || (Lint.Rules = {}));
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var RuleFailurePosition = (function () {
        function RuleFailurePosition(position, lineAndCharacter) {
            this.position = position;
            this.lineAndCharacter = lineAndCharacter;
        }
        RuleFailurePosition.prototype.getPosition = function () {
            return this.position;
        };
        RuleFailurePosition.prototype.getLineAndCharacter = function () {
            return this.lineAndCharacter;
        };
        RuleFailurePosition.prototype.toJson = function () {
            return {
                character: this.lineAndCharacter.character,
                line: this.lineAndCharacter.line,
                position: this.position
            };
        };
        RuleFailurePosition.prototype.equals = function (ruleFailurePosition) {
            var ll = this.lineAndCharacter;
            var rr = ruleFailurePosition.lineAndCharacter;
            return this.position === ruleFailurePosition.position
                && ll.line === rr.line
                && ll.character === rr.character;
        };
        return RuleFailurePosition;
    })();
    Lint.RuleFailurePosition = RuleFailurePosition;
    var RuleFailure = (function () {
        function RuleFailure(sourceFile, start, end, failure, ruleName) {
            this.sourceFile = sourceFile;
            this.fileName = sourceFile.fileName;
            this.startPosition = this.createFailurePosition(start);
            this.endPosition = this.createFailurePosition(end);
            this.failure = failure;
            this.ruleName = ruleName;
        }
        RuleFailure.prototype.getFileName = function () {
            return this.fileName;
        };
        RuleFailure.prototype.getRuleName = function () {
            return this.ruleName;
        };
        RuleFailure.prototype.getStartPosition = function () {
            return this.startPosition;
        };
        RuleFailure.prototype.getEndPosition = function () {
            return this.endPosition;
        };
        RuleFailure.prototype.getFailure = function () {
            return this.failure;
        };
        RuleFailure.prototype.toJson = function () {
            return {
                endPosition: this.endPosition.toJson(),
                failure: this.failure,
                name: this.fileName,
                ruleName: this.ruleName,
                startPosition: this.startPosition.toJson()
            };
        };
        RuleFailure.prototype.equals = function (ruleFailure) {
            return this.failure === ruleFailure.getFailure()
                && this.fileName === ruleFailure.getFileName()
                && this.startPosition.equals(ruleFailure.getStartPosition())
                && this.endPosition.equals(ruleFailure.getEndPosition());
        };
        RuleFailure.prototype.createFailurePosition = function (position) {
            var lineAndCharacter = this.sourceFile.getLineAndCharacterOfPosition(position);
            return new RuleFailurePosition(position, lineAndCharacter);
        };
        return RuleFailure;
    })();
    Lint.RuleFailure = RuleFailure;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var path = require("path");
    function getSourceFile(fileName, source) {
        var normalizedName = path.normalize(fileName).replace(/\\/g, "/");
        var compilerOptions = createCompilerOptions();
        var compilerHost = {
            getCanonicalFileName: function (filename) { return filename; },
            getCurrentDirectory: function () { return ""; },
            getDefaultLibFileName: function () { return "lib.d.ts"; },
            getNewLine: function () { return "\n"; },
            getSourceFile: function (filenameToGet) {
                if (filenameToGet === normalizedName) {
                    return ts.createSourceFile(filenameToGet, source, compilerOptions.target, true);
                }
            },
            useCaseSensitiveFileNames: function () { return true; },
            writeFile: function () { return null; }
        };
        var program = ts.createProgram([normalizedName], compilerOptions, compilerHost);
        return program.getSourceFile(normalizedName);
    }
    Lint.getSourceFile = getSourceFile;
    function createCompilerOptions() {
        return {
            allowNonTsExtensions: true,
            noResolve: true,
            target: 1
        };
    }
    Lint.createCompilerOptions = createCompilerOptions;
    function doesIntersect(failure, disabledIntervals) {
        return disabledIntervals.some(function (interval) {
            var maxStart = Math.max(interval.startPosition, failure.getStartPosition().getPosition());
            var minEnd = Math.min(interval.endPosition, failure.getEndPosition().getPosition());
            return maxStart <= minEnd;
        });
    }
    Lint.doesIntersect = doesIntersect;
    function abstract() {
        return "abstract method not implemented";
    }
    Lint.abstract = abstract;
    function scanAllTokens(scanner, callback) {
        var lastStartPos = -1;
        while (scanner.scan() !== 1) {
            var startPos = scanner.getStartPos();
            if (startPos === lastStartPos) {
                break;
            }
            lastStartPos = startPos;
            callback(scanner);
        }
    }
    Lint.scanAllTokens = scanAllTokens;
    function hasModifier(modifiers) {
        var modifierKinds = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            modifierKinds[_i - 1] = arguments[_i];
        }
        if (modifiers == null || modifierKinds == null) {
            return false;
        }
        return modifiers.some(function (m) {
            return modifierKinds.some(function (k) { return m.kind === k; });
        });
    }
    Lint.hasModifier = hasModifier;
    function isBlockScopedVariable(node) {
        var parentNode = (node.kind === 199)
            ? node.parent
            : node.declarationList;
        return isNodeFlagSet(parentNode, 4096)
            || isNodeFlagSet(parentNode, 8192);
    }
    Lint.isBlockScopedVariable = isBlockScopedVariable;
    function isBlockScopedBindingElement(node) {
        var currentParent = node.parent;
        while (currentParent.kind !== 199) {
            if (currentParent.parent == null) {
                return true;
            }
            else {
                currentParent = currentParent.parent;
            }
        }
        return isBlockScopedVariable(currentParent);
    }
    Lint.isBlockScopedBindingElement = isBlockScopedBindingElement;
    function isNodeFlagSet(node, flagToCheck) {
        return (node.flags & flagToCheck) !== 0;
    }
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var BlockScopeAwareRuleWalker = (function (_super) {
        __extends(BlockScopeAwareRuleWalker, _super);
        function BlockScopeAwareRuleWalker(sourceFile, options) {
            _super.call(this, sourceFile, options);
            this.blockScopeStack = [this.createBlockScope()];
        }
        BlockScopeAwareRuleWalker.prototype.createBlockScope = function () {
            throw Lint.abstract();
        };
        BlockScopeAwareRuleWalker.prototype.getCurrentBlockScope = function () {
            return this.blockScopeStack[this.blockScopeStack.length - 1];
        };
        BlockScopeAwareRuleWalker.prototype.onBlockScopeStart = function () {
            return;
        };
        BlockScopeAwareRuleWalker.prototype.getCurrentBlockDepth = function () {
            return this.blockScopeStack.length;
        };
        BlockScopeAwareRuleWalker.prototype.onBlockScopeEnd = function () {
            return;
        };
        BlockScopeAwareRuleWalker.prototype.visitNode = function (node) {
            var isNewBlockScope = this.isBlockScopeBoundary(node);
            if (isNewBlockScope) {
                this.blockScopeStack.push(this.createBlockScope());
            }
            this.onBlockScopeStart();
            _super.prototype.visitNode.call(this, node);
            this.onBlockScopeEnd();
            if (isNewBlockScope) {
                this.blockScopeStack.pop();
            }
        };
        BlockScopeAwareRuleWalker.prototype.isBlockScopeBoundary = function (node) {
            return _super.prototype.isScopeBoundary.call(this, node)
                || node.kind === 185
                || node.kind === 186
                || node.kind === 187
                || node.kind === 188
                || node.kind === 189
                || node.kind === 193
                || node.kind === 194
                || (node.parent != null
                    && (node.parent.kind === 197
                        || node.parent.kind === 184));
        };
        return BlockScopeAwareRuleWalker;
    })(Lint.ScopeAwareRuleWalker);
    Lint.BlockScopeAwareRuleWalker = BlockScopeAwareRuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2015 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var SkippableTokenAwareRuleWalker = (function (_super) {
        __extends(SkippableTokenAwareRuleWalker, _super);
        function SkippableTokenAwareRuleWalker(sourceFile, options) {
            _super.call(this, sourceFile, options);
            this.tokensToSkipStartEndMap = {};
        }
        SkippableTokenAwareRuleWalker.prototype.visitRegularExpressionLiteral = function (node) {
            this.addTokenToSkipFromNode(node);
            _super.prototype.visitRegularExpressionLiteral.call(this, node);
        };
        SkippableTokenAwareRuleWalker.prototype.visitIdentifier = function (node) {
            this.addTokenToSkipFromNode(node);
            _super.prototype.visitIdentifier.call(this, node);
        };
        SkippableTokenAwareRuleWalker.prototype.visitTemplateExpression = function (node) {
            this.addTokenToSkipFromNode(node);
            _super.prototype.visitTemplateExpression.call(this, node);
        };
        SkippableTokenAwareRuleWalker.prototype.addTokenToSkipFromNode = function (node) {
            if (node.getStart() < node.getEnd()) {
                this.tokensToSkipStartEndMap[node.getStart()] = node.getEnd();
            }
        };
        return SkippableTokenAwareRuleWalker;
    })(Lint.RuleWalker);
    Lint.SkippableTokenAwareRuleWalker = SkippableTokenAwareRuleWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var Configuration;
    (function (Configuration) {
        var fs = require("fs");
        var path = require("path");
        var findup = require("findup-sync");
        var CONFIG_FILENAME = "tslint.json";
        var DEFAULT_CONFIG = {
            "rules": {
                "curly": true,
                "indent": [true, 4],
                "no-duplicate-key": true,
                "no-duplicate-variable": true,
                "no-empty": true,
                "no-eval": true,
                "no-trailing-whitespace": true,
                "no-unreachable": true,
                "no-use-before-declare": true,
                "quotemark": [true, "double"],
                "semicolon": true
            }
        };
        function findConfiguration(configFile, inputFileLocation) {
            if (configFile) {
                return JSON.parse(fs.readFileSync(configFile, "utf8"));
            }
            configFile = findup("package.json", { cwd: inputFileLocation, nocase: true });
            if (configFile) {
                var content = require(configFile);
                if (content.tslintConfig) {
                    return content.tslintConfig;
                }
            }
            var homeDir = getHomeDir();
            if (!homeDir) {
                return undefined;
            }
            var defaultPath = path.join(homeDir, CONFIG_FILENAME);
            configFile = findup(CONFIG_FILENAME, { cwd: inputFileLocation, nocase: true }) || defaultPath;
            if (fs.existsSync(configFile)) {
                return JSON.parse(fs.readFileSync(configFile, "utf8"));
            }
            else {
                return DEFAULT_CONFIG;
            }
        }
        Configuration.findConfiguration = findConfiguration;
        function getHomeDir() {
            var environment = global.process.env;
            var paths = [environment.USERPROFILE, environment.HOME, environment.HOMEPATH, environment.HOMEDRIVE + environment.HOMEPATH];
            for (var homeIndex in paths) {
                if (paths.hasOwnProperty(homeIndex)) {
                    var homePath = paths[homeIndex];
                    if (homePath && fs.existsSync(homePath)) {
                        return homePath;
                    }
                }
            }
        }
    })(Configuration = Lint.Configuration || (Lint.Configuration = {}));
})(Lint || (Lint = {}));
/*
 * Copyright 2014 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var EnableDisableRulesWalker = (function (_super) {
        __extends(EnableDisableRulesWalker, _super);
        function EnableDisableRulesWalker() {
            _super.apply(this, arguments);
            this.enableDisableRuleMap = {};
        }
        EnableDisableRulesWalker.prototype.visitSourceFile = function (node) {
            var _this = this;
            _super.prototype.visitSourceFile.call(this, node);
            Lint.scanAllTokens(ts.createScanner(1, false, node.text), function (scanner) {
                var startPos = scanner.getStartPos();
                if (_this.tokensToSkipStartEndMap[startPos] != null) {
                    scanner.setTextPos(_this.tokensToSkipStartEndMap[startPos]);
                    return;
                }
                if (scanner.getToken() === 3) {
                    var commentText = scanner.getTokenText();
                    var startPosition = scanner.getTokenPos();
                    _this.handlePossibleTslintSwitch(commentText, startPosition);
                }
            });
        };
        EnableDisableRulesWalker.prototype.handlePossibleTslintSwitch = function (commentText, startingPosition) {
            var _this = this;
            var currentPosition = startingPosition;
            if (commentText.match(/^\/\*\s*tslint:/)) {
                var commentTextParts = commentText.split(":");
                var enableOrDisableMatch = commentTextParts[1].match(/^(enable|disable)(\s|$)/);
                if (enableOrDisableMatch != null) {
                    var isEnabled = enableOrDisableMatch[1] === "enable";
                    var position = currentPosition;
                    var rulesList = ["all"];
                    if (commentTextParts.length > 2) {
                        rulesList = commentTextParts[2].split(/\s+/);
                    }
                    rulesList.forEach(function (ruleToAdd) {
                        if (!(ruleToAdd in _this.enableDisableRuleMap)) {
                            _this.enableDisableRuleMap[ruleToAdd] = [];
                        }
                        _this.enableDisableRuleMap[ruleToAdd].push({
                            isEnabled: isEnabled,
                            position: position
                        });
                    });
                }
            }
        };
        return EnableDisableRulesWalker;
    })(Lint.SkippableTokenAwareRuleWalker);
    Lint.EnableDisableRulesWalker = EnableDisableRulesWalker;
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var fs = require("fs");
    var path = require("path");
    var _s = require("underscore.string");
    var moduleDirectory = path.dirname(module.filename);
    var CORE_FORMATTERS_DIRECTORY = path.resolve(moduleDirectory, "..", "build", "formatters");
    function findFormatter(name, formattersDirectory) {
        if (typeof (name) === "function") {
            return name;
        }
        var camelizedName = _s.camelize(name + "Formatter");
        var Formatter = loadFormatter(CORE_FORMATTERS_DIRECTORY, camelizedName);
        if (Formatter) {
            return Formatter;
        }
        if (formattersDirectory) {
            Formatter = loadFormatter(formattersDirectory, camelizedName);
            if (Formatter) {
                return Formatter;
            }
        }
        return loadFormatterModule(name);
    }
    Lint.findFormatter = findFormatter;
    function loadFormatter() {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i - 0] = arguments[_i];
        }
        var formatterPath = paths.reduce(function (p, c) { return path.join(p, c); }, "");
        var fullPath = path.resolve(moduleDirectory, formatterPath);
        if (fs.existsSync(fullPath + ".js")) {
            var formatterModule = require(fullPath);
            return formatterModule.Formatter;
        }
        return undefined;
    }
    function loadFormatterModule(name) {
        var src;
        try {
            src = require.resolve(name);
        }
        catch (e) {
            return undefined;
        }
        return require(src).Formatter;
    }
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var fs = require("fs");
    var path = require("path");
    var _s = require("underscore.string");
    var moduleDirectory = path.dirname(module.filename);
    var CORE_RULES_DIRECTORY = path.resolve(moduleDirectory, "..", "build", "rules");
    function loadRules(ruleConfiguration, enableDisableRuleMap, rulesDirectory) {
        var rules = [];
        for (var ruleName in ruleConfiguration) {
            if (ruleConfiguration.hasOwnProperty(ruleName)) {
                var ruleValue = ruleConfiguration[ruleName];
                var Rule = findRule(ruleName, rulesDirectory);
                if (Rule !== undefined) {
                    var all = "all";
                    var allList = (all in enableDisableRuleMap ? enableDisableRuleMap[all] : []);
                    var ruleSpecificList = (ruleName in enableDisableRuleMap ? enableDisableRuleMap[ruleName] : []);
                    var disabledIntervals = buildDisabledIntervalsFromSwitches(ruleSpecificList, allList);
                    rules.push(new Rule(ruleName, ruleValue, disabledIntervals));
                }
            }
        }
        return rules;
    }
    Lint.loadRules = loadRules;
    function findRule(name, rulesDirectory) {
        var camelizedName = transformName(name);
        var Rule = loadRule(CORE_RULES_DIRECTORY, camelizedName);
        if (Rule) {
            return Rule;
        }
        if (rulesDirectory) {
            Rule = loadRule(rulesDirectory, camelizedName);
            if (Rule) {
                return Rule;
            }
        }
        if (rulesDirectory) {
            var subDirectory = _s.strLeft(rulesDirectory, "-");
            var ruleName = _s.strRight(rulesDirectory, "-");
            if (subDirectory !== rulesDirectory && ruleName !== rulesDirectory) {
                camelizedName = transformName(ruleName);
                Rule = loadRule(rulesDirectory, subDirectory, camelizedName);
                if (Rule) {
                    return Rule;
                }
            }
        }
        return undefined;
    }
    Lint.findRule = findRule;
    function transformName(name) {
        var nameMatch = name.match(/^([-_]*)(.*?)([-_]*)$/);
        if (nameMatch == null) {
            return name + "Rule";
        }
        return nameMatch[1] + _s.camelize(nameMatch[2]) + nameMatch[3] + "Rule";
    }
    function loadRule() {
        var paths = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            paths[_i - 0] = arguments[_i];
        }
        var rulePath = paths.reduce(function (p, c) { return path.join(p, c); }, "");
        var fullPath = path.resolve(moduleDirectory, rulePath);
        if (fs.existsSync(fullPath + ".js")) {
            var ruleModule = require(fullPath);
            if (ruleModule && ruleModule.Rule) {
                return ruleModule.Rule;
            }
        }
        return undefined;
    }
    function buildDisabledIntervalsFromSwitches(ruleSpecificList, allList) {
        var isCurrentlyDisabled = false;
        var disabledStartPosition;
        var disabledIntervalList = [];
        var i = 0;
        var j = 0;
        while (i < ruleSpecificList.length || j < allList.length) {
            var ruleSpecificTopPositon = (i < ruleSpecificList.length ? ruleSpecificList[i].position : Infinity);
            var allTopPositon = (j < allList.length ? allList[j].position : Infinity);
            var newPositionToCheck = void 0;
            if (ruleSpecificTopPositon < allTopPositon) {
                newPositionToCheck = ruleSpecificList[i];
                i++;
            }
            else {
                newPositionToCheck = allList[j];
                j++;
            }
            if (newPositionToCheck.isEnabled === isCurrentlyDisabled) {
                if (!isCurrentlyDisabled) {
                    disabledStartPosition = newPositionToCheck.position;
                    isCurrentlyDisabled = true;
                }
                else {
                    disabledIntervalList.push({
                        endPosition: newPositionToCheck.position,
                        startPosition: disabledStartPosition
                    });
                    isCurrentlyDisabled = false;
                }
            }
        }
        if (isCurrentlyDisabled) {
            disabledIntervalList.push({
                endPosition: Infinity,
                startPosition: disabledStartPosition
            });
        }
        return disabledIntervalList;
    }
})(Lint || (Lint = {}));
/*
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Lint;
(function (Lint) {
    var path = require("path");
    var moduleDirectory = path.dirname(module.filename);
    var Linter = (function () {
        function Linter(fileName, source, options) {
            this.fileName = fileName;
            this.source = source;
            this.options = options;
        }
        Linter.prototype.lint = function () {
            var failures = [];
            var sourceFile = Lint.getSourceFile(this.fileName, this.source);
            var rulesWalker = new Lint.EnableDisableRulesWalker(sourceFile, {
                disabledIntervals: [],
                ruleName: ""
            });
            rulesWalker.walk(sourceFile);
            var enableDisableRuleMap = rulesWalker.enableDisableRuleMap;
            var rulesDirectory = this.getRelativePath(this.options.rulesDirectory);
            var configuration = this.options.configuration.rules;
            var configuredRules = Lint.loadRules(configuration, enableDisableRuleMap, rulesDirectory);
            for (var _i = 0; _i < configuredRules.length; _i++) {
                var rule = configuredRules[_i];
                if (rule.isEnabled()) {
                    var ruleFailures = rule.apply(sourceFile);
                    for (var _a = 0; _a < ruleFailures.length; _a++) {
                        var ruleFailure = ruleFailures[_a];
                        if (!this.containsRule(failures, ruleFailure)) {
                            failures.push(ruleFailure);
                        }
                    }
                }
            }
            var formatter;
            var formattersDirectory = this.getRelativePath(this.options.formattersDirectory);
            var Formatter = Lint.findFormatter(this.options.formatter, formattersDirectory);
            if (Formatter) {
                formatter = new Formatter();
            }
            else {
                throw new Error("formatter '" + this.options.formatter + "' not found");
            }
            var output = formatter.format(failures);
            return {
                failureCount: failures.length,
                format: this.options.formatter,
                output: output
            };
        };
        Linter.prototype.getRelativePath = function (directory) {
            if (directory) {
                return path.relative(moduleDirectory, directory);
            }
            return undefined;
        };
        Linter.prototype.containsRule = function (rules, rule) {
            return rules.some(function (r) { return r.equals(rule); });
        };
        Linter.VERSION = "2.3.1-beta";
        return Linter;
    })();
    Lint.Linter = Linter;
})(Lint || (Lint = {}));
global.Lint = Lint;
global.ts = ts;
module.exports = Lint.Linter;
module.exports.findConfiguration = Lint.Configuration.findConfiguration;
